<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '~/plugins/contentful';
import { CONTENT_TYPES } from '~/common/content-types';
import { getPageMetadata } from '~/common/meta';
import { FooterEditLinkMixin } from '~/mixins';
import { micrositeDataHelper } from '~/services/microsites/microsite.service';

import {
  MicrositeCtaTabs,
  MicrositeFooterCta,
  MicrositeNavigation,
  MicrositePageBody,
} from '~/components/microsites/index.vue';
export default Vue.extend({
  components: {
    MicrositeNavigation,
    MicrositePageBody,
    MicrositeFooterCta,
    MicrositeCtaTabs,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: false,
  layout: 'microsite',
  async asyncData({ params }) {
    try {
      const micrositeSlug = params.partner;
      const micrositeData = await getClient().getEntries({
        'fields.slug': micrositeSlug,
        content_type: CONTENT_TYPES.MICROSITE,
        include: 10,
      });

      const [items] = micrositeData.items;
      const metadata = items.fields.seoMetadata.fields;
      const spaceId = micrositeData.items[0].sys.space.sys.id;
      const entryId = micrositeData.items[0].sys.id;

      const data = micrositeDataHelper(items.fields);
      return { metadata, data, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    try {
      const metadata = {
        ...(this.metadata || {}),
        noIndex: true,
      };
      return getPageMetadata(metadata, this.$route.path);
    } catch (e) {
      throw new Error(e);
    }
  },
  created() {
    // Check if 'utm_partnerid=' exists in the URL
    if (!this.$route.fullPath.includes('utm_partnerid=')) {
      const newUrl =
        this.$route.fullPath +
        (this.$route.fullPath.includes('?') ? '&' : '?') +
        `utm_partnerid=${this.data.partner.id}`;
      this.$router.replace(newUrl);
    }
  },
});
</script>
<template>
  <div>
    <MicrositeNavigation
      :partner="data.partner"
      :navigation="data.navigation"
    />
    <main>
      <SlpContainer>
        <SlpTypography class="header" variant="heading1-bold" tag="h1">
          {{ data.content.heading }}
        </SlpTypography>
        <MicrositeCtaTabs
          class="mobile-tabs"
          :data="data.content.body.sideMenu.tabs"
          :partner="data.partner"
        />
        <div class="main-content">
          <MicrositePageBody :data="data.content.body" />
        </div>
      </SlpContainer>
    </main>
    <SlpContainer variant="gradient">
      <MicrositeFooterCta :data="data.footerCta.data" :partner="data.partner" />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
main {
  margin-top: 16px;
}
.header {
  display: block;
  width: 75%;

  @media (max-width: $breakpoint-md) {
    width: 100%;
  }
}

.mobile-tabs {
  display: none;

  @media (max-width: $breakpoint-md) {
    margin-top: 32px;
    display: block;
  }
}

.main-content {
  padding-top: 64px;

  @media (max-width: $breakpoint-md) {
    padding-top: 0;
  }
}
</style>
